### org.jfree.layouting.renderer

# Class PrototypeBuildingRenderer

- `java.lang.Object`
- - `org.jfree.layouting.renderer.PrototypeBuildingRenderer`

Implemented Interfaces:
  Renderer, StatefullComponent

`public class PrototypeBuildingRenderer`
`extends java.lang.Object`
`implements Renderer`

This renderer does not build real output. This renderer fills in prototype element definitions and is later used to spit them out when requested. Prototypes are filled in in the first stage of the renderering and are reused in all subsequent stages. This class needs to be implemented later.

Author:
  Thomas Morgner

See Also:
  `http://www.w3.org/TR/css3-gcpm/.generated`

  ## Constructor Summary

  `PrototypeBuildingRenderer(LayoutProcess layoutProcess)`

  ## Method Summary

  `void`

  `addContent(LayoutContext context, ContentToken content)`

  `void`

  `addPassThroughContent(LayoutContext context, ContentToken content)`

  `void`

  `finishedBlock()`

  `void`

  `finishedDocument()`

  `void`

  `finishedFlow()`

  `void`

  `finishedInline()`

  `void`

  `finishedMarker()`

  `void`

  `finishedPassThrough()`

  `void`

  `finishedRootInline()`

  `void`

  `finishedTable()`

  `void`

  `finishedTableCaption()`

  `void`

  `finishedTableCell()`

  `void`

  `finishedTableColumn()`

  `void`

  `finishedTableColumnGroup()`

  `void`

  `finishedTableRow()`

  `void`

  `finishedTableSection()`

  `void`

  `handlePageBreak(PageContext pageContext)`
    A call-back that informs the renderer, that a new page must be started.

  `State`

  `saveState()`

  `void`

  `startedBlock(LayoutContext context)`

  `void`

  `startedDocument(PageContext pageContext)`
    Starts the document and initalizes the default page context.

  `void`

  `startedFlow(LayoutContext context)`
    Starts a floating, absolute or static element.

  `void`

  `startedInline(LayoutContext context)`

  `void`

  `startedMarker(LayoutContext context)`

  `void`

  `startedPassThrough(LayoutContext context)`

  `void`

  `startedRootInline(LayoutContext context)`

  `void`

  `startedTable(LayoutContext layoutContext)`

  `void`

  `startedTableCaption(LayoutContext context)`

  `void`

  `startedTableCell(LayoutContext layoutContext)`

  `void`

  `startedTableColumn(LayoutContext context)`

  `void`

  `startedTableColumnGroup(LayoutContext context)`

  `void`

  `startedTableRow(LayoutContext layoutContext)`

  `void`

  `startedTableSection(LayoutContext layoutContext)`

## Constructor Details

### PrototypeBuildingRenderer

    public PrototypeBuildingRenderer(LayoutProcess layoutProcess)

## Method Details

### addContent

    public void addContent(LayoutContext context,
                           ContentToken content)
                throws NormalizationException

> Specified by:
>   addContent in interface Renderer

### addPassThroughContent

    public void addPassThroughContent(LayoutContext context,
                                      ContentToken content)

> Specified by:
>   addPassThroughContent in interface Renderer

### finishedBlock

    public void finishedBlock()
                throws NormalizationException

> Specified by:
>   finishedBlock in interface Renderer

### finishedDocument

    public void finishedDocument()
                throws NormalizationException

> Specified by:
>   finishedDocument in interface Renderer

### finishedFlow

    public void finishedFlow()
                throws NormalizationException

> Specified by:
>   finishedFlow in interface Renderer

### finishedInline

    public void finishedInline()
                throws NormalizationException

> Specified by:
>   finishedInline in interface Renderer

### finishedMarker

    public void finishedMarker()
                throws NormalizationException

> Specified by:
>   finishedMarker in interface Renderer

### finishedPassThrough

    public void finishedPassThrough()

> Specified by:
>   finishedPassThrough in interface Renderer

### finishedRootInline

    public void finishedRootInline()
                throws NormalizationException

> Specified by:
>   finishedRootInline in interface Renderer

### finishedTable

    public void finishedTable()
                throws NormalizationException

> Specified by:
>   finishedTable in interface Renderer

### finishedTableCaption

    public void finishedTableCaption()
                throws NormalizationException

> Specified by:
>   finishedTableCaption in interface Renderer

### finishedTableCell

    public void finishedTableCell()
                throws NormalizationException

> Specified by:
>   finishedTableCell in interface Renderer

### finishedTableColumn

    public void finishedTableColumn()
                throws NormalizationException

> Specified by:
>   finishedTableColumn in interface Renderer

### finishedTableColumnGroup

    public void finishedTableColumnGroup()
                throws NormalizationException

> Specified by:
>   finishedTableColumnGroup in interface Renderer

### finishedTableRow

    public void finishedTableRow()
                throws NormalizationException

> Specified by:
>   finishedTableRow in interface Renderer

### finishedTableSection

    public void finishedTableSection()
                throws NormalizationException

> Specified by:
>   finishedTableSection in interface Renderer

### handlePageBreak

    public void handlePageBreak(PageContext pageContext)

> A call-back that informs the renderer, that a new page must be started. This closes the old page context and copies all pending content to the new context.

> This method is triggered by a call to 'LayoutProcess.pageBreakEncountered'
> Specified by:
>   handlePageBreak in interface Renderer
> Parameters:
>   `pageContext` -

### saveState

    public State saveState()
                throws StateException

> Specified by:
>   saveState in interface StatefullComponent

### startedBlock

    public void startedBlock(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedBlock in interface Renderer

### startedDocument

    public void startedDocument(PageContext pageContext)

> Starts the document and initalizes the default page context.
> Specified by:
>   startedDocument in interface Renderer
> Parameters:
>   `pageContext` -

### startedFlow

    public void startedFlow(LayoutContext context)
                throws NormalizationException

> Starts a floating, absolute or static element. This establishes a new normal flow for the element.
> Specified by:
>   startedFlow in interface Renderer
> Parameters:
>   `context` -

### startedInline

    public void startedInline(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedInline in interface Renderer

### startedMarker

    public void startedMarker(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedMarker in interface Renderer

### startedPassThrough

    public void startedPassThrough(LayoutContext context)

> Specified by:
>   startedPassThrough in interface Renderer

### startedRootInline

    public void startedRootInline(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedRootInline in interface Renderer

### startedTable

    public void startedTable(LayoutContext layoutContext)
                throws NormalizationException

> Specified by:
>   startedTable in interface Renderer

### startedTableCaption

    public void startedTableCaption(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedTableCaption in interface Renderer

### startedTableCell

    public void startedTableCell(LayoutContext layoutContext)
                throws NormalizationException

> Specified by:
>   startedTableCell in interface Renderer

### startedTableColumn

    public void startedTableColumn(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedTableColumn in interface Renderer

### startedTableColumnGroup

    public void startedTableColumnGroup(LayoutContext context)
                throws NormalizationException

> Specified by:
>   startedTableColumnGroup in interface Renderer

### startedTableRow

    public void startedTableRow(LayoutContext layoutContext)
                throws NormalizationException

> Specified by:
>   startedTableRow in interface Renderer

### startedTableSection

    public void startedTableSection(LayoutContext layoutContext)
                throws NormalizationException

> Specified by:
>   startedTableSection in interface Renderer